﻿Type=Class
Version=6.8
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
'Events declaration
#Event: Result(res() As Int)

Sub Class_Globals
	
	Private closebtn As Button
	Private cnvs As Canvas
	Private cx, cy, r1, r2 As Float
	Private selectedcolor, initColor As Int
	Private colorbtn As  Button 'Label
	Private mymodule As Object
	Private backpnl, basepnl, palette, pltcursor As Panel
	Private myname As String
	Private pnlTest, pnlAlpha As Panel
	Private barAlpha As SeekBar
	Private lblTransp  As Label
	Private res(4) As Int
	
End Sub

'Initializes the object.
Public Sub Initialize(Parent As Activity, Module As Object, Eventname As String, Background As Int, initClr As Int)
	
	mymodule = Module
	myname = Eventname
	initColor = initClr
	
	res = ParseColor(initColor)

	Dim CF As Double =  Sqrt((100%y * 100%y + 100%x * 100%x)/(Power(430 * Density,2) + Power(800 * Density,2))) 

	backpnl.Initialize("backpnl")
	backpnl.Color = Colors.Black
	
	Parent.AddView(backpnl,0,0,100%x,100%y)
	
	basepnl.Initialize("")
	basepnl.color = Background

	palette.Initialize("palette")

	pltcursor.Initialize("")
	pltcursor.SetBackgroundImage(LoadBitmap(File.DirAssets,"cursor.png"))

	Dim dr As ColorDrawable
		dr.Initialize2(Colors.RGB(res(1), res(2), res(3)),1%x, 1dip, Colors.transparent)
		
	closebtn.Initialize("closebtn")
	closebtn.Background = dr
	closebtn.Typeface = Typeface.DEFAULT_BOLD
	closebtn.Text = "Cancel"
	closebtn.TextSize = 20 * CF
	
	selectedcolor = Colors.RGB(res(1), res(2), res(3))  'Set initial button color without Alpha
	dr.Initialize2(selectedcolor, 1%x, 1dip, Colors.transparent)
	colorbtn.Initialize("colorbtn")
	colorbtn.Background = dr
	colorbtn.text = "OK"
	colorbtn.Typeface = Typeface.DEFAULT_BOLD
	colorbtn.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, Gravity.CENTER_HORIZONTAL)
	colorbtn.textsize = 20 * CF
	
	If (res(1)+res(2)+res(3)) > 240 Then 
		colorbtn.TextColor = Colors.Black
		closebtn.TextColor = Colors.Black
	Else
		colorbtn.TextColor = Colors.White
		closebtn.TextColor = Colors.White
	End If
	

Dim bmp As Bitmap
	bmp.Initialize(File.DirAssets,"RPC.png")

Dim rect0,rect1 As Rect
	rect0.Initialize(0,0,bmp.Width,bmp.Height)
		
	backpnl.AddView(basepnl,10%x,10%y,80%x,95%x)
	basepnl.AddView(palette,0,0,80%x,80%x)
	
	cx = 40%x
	cy = 40%x
	r1 = 29%x
	r2 = 40%x
	
   'basepnl.AddView(pltcursor,cx-15%x,cy+7%x,2%x,2%x) ' <- original
	basepnl.AddView(pltcursor, 0, 0, 2%x,2%x) 'Place cursor initially in the upper left corner
	
	rect1.Initialize(10%x,10%x,70%x,70%x)
		
	basepnl.AddView(closebtn,  	            0, 81%x, basepnl.Width/2, 11%x)
	basepnl.AddView(colorbtn, basepnl.Width/2, 81%x, basepnl.Width/2, 11%x)
	
	cnvs.Initialize(palette)
	cnvs.DrawBitmap(bmp,rect0,rect1)
	backpnl.Visible = False
	
'===== transparency items =====
	
	pnlTest.Initialize("")
	pnlTest.SetBackgroundImage(LoadBitmap(File.DirAssets,"landscape.jpg"))
	backpnl.AddView(pnlTest, basepnl.Left, basepnl.Top + basepnl.Height, basepnl.Width, 20%y)
	
	pnlAlpha.Initialize("")
	pnlAlpha.Color = initColor		
	backpnl.AddView(pnlAlpha, basepnl.Left + basepnl.Width/2, basepnl.Top+basepnl.Height, basepnl.Width/2, 20%y)
	
	lblTransp.Initialize("")
	lblTransp.Text = "Transparency"
	lblTransp.Gravity = Gravity.LEFT
	backpnl.AddView(lblTransp, basepnl.Left, pnlTest.Top + pnlTest.Height + 5dip, basepnl.Width, 30dip)
	
	barAlpha.Initialize("barAlpha")
	barAlpha.Max = 255
	barAlpha.Value = 255 - res(0) 'Alpha value for initColor
	backpnl.AddView(barAlpha, basepnl.Left, lblTransp.Top + lblTransp.Height, basepnl.Width, 30dip)

'===============

End Sub

Public Sub AsView As View
	Return backpnl
End Sub

Private Sub drawlum  

'Dim res() As Int 
	res = ParseColor(selectedcolor)
	
Dim col As Int

Dim delR1,delG1,delB1,delR2,delG2,delB2 As Double

	delR1 = (255-res(1))/360
	delG1 = (255-res(2))/360
	delB1 = (255-res(3))/360
	delR2 = res(1)/360
	delG2 = res(2)/360
	delB2 = res(3)/360

	
	For i = 0 To 360
		
		col = Colors.RGB(255-i * delR1,255- i*delG1,255- i*delB1)
		cnvs.DrawLine(cx+r1*SinD(i/2),cy-r1*CosD(i/2),cx+r2*SinD(i/2),cy-r2*CosD(i/2),col,4)
		
		col = Colors.RGB(i * delR2, i*delG2,i*delB2)
		cnvs.DrawLine(cx+r1*SinD(-i/2),cy-r1*CosD(-i/2),cx+r2*SinD(-i/2),cy-r2*CosD(-i/2),col,4)
		
	Next

	palette.Invalidate
	
End Sub

Private Sub ParseColor(clr As Int) As Int()

	res(0) = Bit.UnsignedShiftRight(Bit.And(clr, 0xff000000), 24) ' alfa
	res(1) = Bit.UnsignedShiftRight(Bit.And(clr, 0xff0000), 16)   ' R
	res(2) = Bit.UnsignedShiftRight(Bit.And(clr, 0xff00), 8)      ' G
	res(3) = Bit.And(clr, 0xff)  ' B
		
	Return res
	
End Sub

'Shows the palette and enables choosing the color. 
'Ruturns the color as Int and As A,R,G,B In Sub Eventname_Result In the calling module.

Public Sub GetColor 
	
	drawlum
	backpnl.Visible = True
	
End Sub

Private Sub colorbtn_click
	
	backpnl.Visible = False
			
	Dim cl(4) As Int
		cl(0) = 255 - barAlpha.value
		cl(1) = res(1)
		cl(2) = res(2)
		cl(3) = res(3)
		
	CallSub2(mymodule, myname & "_Result", cl)
	
End Sub

Private Sub closebtn_click
	
	res = ParseColor(initColor)
	
	backpnl.Visible = False
			
	Dim cl(4) As Int
		cl(0) = 255 - barAlpha.value
		cl(1) = res(1)
		cl(2) = res(2)
		cl(3) = res(3)
		
	CallSub2(mymodule, myname & "_Result", cl)

	
End Sub

Private Sub palette_Touch (Action As Int, X As Float, Y As Float)
		
	selectedcolor = cnvs.Bitmap.GetPixel(X,Y) 'No Alpha information
	
	res = ParseColor(selectedcolor)

	If Sqrt((cx-X)*(cx-X)+(cy-Y)*(cy-Y)) < r1 Then  drawlum

	If (res(1)+res(2)+res(3)) > 240 Then
		colorbtn.TextColor = Colors.Black
	Else
		colorbtn.TextColor = Colors.white
	End If
	

	colorbtn.Color = Colors.RGB(res(1), res(2), res(3))
	
	pltcursor.SetLayout(X-pltcursor.Width/2,Y-pltcursor.Height/2,pltcursor.Width,pltcursor.height)
	
	pnlAlpha.Color = Colors.ARGB(255 - barAlpha.value, res(1), res(2), res(3))
	
End Sub

Sub barAlpha_ValueChanged (Value As Int, UserChanged As Boolean)
	
	pnlAlpha.Color = Colors.ARGB(255 - Value, res(1), res(2), res(3))
	
End Sub

Private Sub  backpnl_Touch (Action As Int, X As Float, Y As Float)
	
End Sub
